package com.example.sslogger;

import android.os.Bundle;
import android.os.Handler;
import android.os.ResultReceiver;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningServiceInfo;
import android.content.Context;
import android.content.Intent;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends Activity {
	MyResultReceiver fileNameReceiver;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		updateStatus();
	}
	
	@Override
	protected void onPause(){
		super.onPause();
	}
	
	@Override
	protected void onResume(){
		super.onResume();
		updateStatus();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		updateStatus();
		return true;
	}

	public void start_logging(View view){
		// Create a new Intent
		Intent mServiceIntent = new Intent(this, SsLoggingService.class);
		fileNameReceiver = new MyResultReceiver(null);
		mServiceIntent.putExtra("file_name_receiver", fileNameReceiver);
		// Starts the IntentService
		startService(mServiceIntent);
		updateStatus();
	}
	
	public void stop_logging(View view){
		if(isServiceRunning()){
			Intent mServiceIntent = new Intent(this, SsLoggingService.class);
			stopService(mServiceIntent);
			updateStatus();
		}
		else{
			setStatus("Cannot stop logging: SsLoggingService not running");
		}
	}
	
	private void updateStatus(){
		if(isServiceRunning()){
			setStatus("SsLoggingService running");
		}
		else{
			setStatus("SsLoggingService not running");
		}
	}
	
	private void setStatus(String status){
		TextView view = (TextView) findViewById(R.id.status);
		view.setText(status);
	}
	
	private boolean isServiceRunning(){
		ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
		for(RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)){
			if(SsLoggingService.class.getName().equals(service.service.getClassName())){
				return true;
			}
		}
		return false;
	}
	
	/* For update status text to show file name returned by service */
	class UpdateUi implements Runnable{
		String updateString;
		public UpdateUi(String updateString){
			this.updateString = updateString;
		}
		public void run(){
			setStatus("SsLoggingService stopped, file saved to " + updateString);
		}
	}
	
	class MyResultReceiver extends ResultReceiver{
		public MyResultReceiver(Handler handler) {
			super(handler);
		}

		@Override
		protected void onReceiveResult(int resultCode, Bundle resultData){
			runOnUiThread(new UpdateUi(resultData.getString("fileName")));
		}
	}
}
