package com.example.sslogger;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.RandomAccessFile;

import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.wifi.WifiManager;
import android.os.IBinder;
import android.telephony.PhoneStateListener;
import android.telephony.SignalStrength;
import android.telephony.TelephonyManager;
import android.widget.Toast;

public class SsLoggingService extends Service {
	OutputStreamWriter osw;
	OutputStreamWriter cpu_osw;
	PollingThread pt;
	public SsLoggingService() {
		//super("SsLoggingService");
	}
	
	public class PollingThread extends Thread {
		String logFileName;
		public PollingThread(String logFileName) {
			this.logFileName = logFileName;
		}
		
		public void run() {
        	String cpuFileName = logFileName.concat(".cpu");
        	FileOutputStream cpu_out;
			try {
				cpu_out = openFileOutput(cpuFileName, Context.MODE_PRIVATE);
	        	cpu_osw = new OutputStreamWriter(cpu_out);
	        	while (true) {
	        		// This change is for nexus one
	    			cpu_osw.write(System.currentTimeMillis() + " " + readUsage() + " " + cpuFrequency(0) + " " + cpuFrequency(1) + "\n");
	        		//cpu_osw.write(System.currentTimeMillis() + " " + readUsage() + " " + cpuFrequency(0) + " " + "-1" + "\n");
	    			try {
						Thread.sleep(50);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
	    		}
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		String logFileName = Long.toString(System.currentTimeMillis());
		String ssFileName = logFileName + ".ss";
		try{
        	FileOutputStream fout = openFileOutput(ssFileName, Context.MODE_PRIVATE);
        	osw = new OutputStreamWriter(fout);
        	//osw.write("time     lte_signalstrength     lte_rsrp     lte_rsrq\n");
        	TelephonyManager tm = (TelephonyManager) getSystemService(TELEPHONY_SERVICE);
        	tm.listen(new PhoneStateListener() {           
        		@Override
        		public void onSignalStrengthsChanged(SignalStrength ss) {
        			if(ss != null){
        				String sss[] = ss.toString().split(" ");
        				int gsm_dbm = ss.getGsmSignalStrength()*2 - 113;
        				//int cdma_dbm = ss.getCdmaDbm();
        				//int evdo_dbm = ss.getEvdoDbm();
        				if(sss.length >= 10){
        					try {
								osw.write(Long.toString(System.currentTimeMillis()) + " gsm " + Integer.toString(gsm_dbm) + " lte " + sss[8] + " " + sss[9] + " " + sss[10] + "\n");
							} catch (IOException e) {
							}
        				}
        				else{
        					try {
        						osw.write(Long.toString(System.currentTimeMillis()) + " gsm " + Integer.toString(gsm_dbm) + "\n");
        					} catch (IOException e) {
        					}
        				}
        			}
        		}
        	}, PhoneStateListener.LISTEN_SIGNAL_STRENGTHS);
        	
        	// write the initial WiFi and Cellular signal strength
        	WifiManager wm = (WifiManager) getSystemService(WIFI_SERVICE);
        	osw.write(Long.toString(System.currentTimeMillis()) + " wifi " + Integer.toString(wm.getConnectionInfo().getRssi()) + "\n");
        	
        	this.registerReceiver(this.myWifiReceiver, new IntentFilter(WifiManager.RSSI_CHANGED_ACTION));
        	
        	pt = new PollingThread(logFileName);
        	pt.start();
        	
        	/*String cpuFileName = logFileName.concat(".cpu");
        	FileOutputStream cpu_out = openFileOutput(cpuFileName, Context.MODE_PRIVATE);
        	cpu_osw = new OutputStreamWriter(cpu_out);
        	while (true) {
    			cpu_osw.write(System.currentTimeMillis() + " " + readUsage() + " " + cpuFrequency(0) + " " + cpuFrequency(1) + "\n");
    			try {
					Thread.sleep(50);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
    		}*/
        }
        catch(IOException e){
        }
		return START_STICKY;
	}
	
	public void onCreate(){
		super.onCreate();
		Toast.makeText(this, "Service Started", Toast.LENGTH_SHORT).show();
	}
	
	public void onDestroy(){
		TelephonyManager tm = (TelephonyManager) getSystemService(TELEPHONY_SERVICE);
		tm.listen(null, PhoneStateListener.LISTEN_NONE);
		this.unregisterReceiver(this.myWifiReceiver);
		try {
			osw.flush();
			osw.close();
			pt.interrupt();
			cpu_osw.flush();
			cpu_osw.close();
		} catch (IOException e) {
			Toast.makeText(this, "osw.flush/close: IOException", Toast.LENGTH_SHORT).show();
		}
		Toast.makeText(this, "Service Destroyed", Toast.LENGTH_SHORT).show();
		super.onDestroy();
	}

	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
	private BroadcastReceiver myWifiReceiver
	= new BroadcastReceiver(){
		@Override
		public void onReceive(Context arg0, Intent arg1){
			int newRssi = arg1.getIntExtra(WifiManager.EXTRA_NEW_RSSI, 0);
			try {
				osw.write(Long.toString(System.currentTimeMillis()) + " wifi " + Integer.toString(newRssi) + "\n");
			} catch (IOException e) {
			}
		}
	};
	
	
	
	private static String parseProcStat(String line) {
        String[] toks = line.split("\\s+");

        long idle1 = Long.parseLong(toks[4]);
        long cpu1 = Long.parseLong(toks[1]) + Long.parseLong(toks[2]) + Long.parseLong(toks[3])
              + Long.parseLong(toks[5]) + Long.parseLong(toks[6]) + Long.parseLong(toks[7]);
        return idle1 + " " + cpu1;
	}

	//changed by Ana
	private static String readUsage() {
	    try {
	        RandomAccessFile reader = new RandomAccessFile("/proc/stat", "r");
	        String load = reader.readLine();
	        String sumCPU = parseProcStat(load);
	        load = reader.readLine();
	        String cpu1 = parseProcStat(load);
	        reader.close();
	        return sumCPU + " " + cpu1;
	        /*String load = reader.readLine();
	        String load_cpu0 = reader.readLine();
	        return load + " " + load_cpu0;*/ 
	    } catch (IOException ex) {
	        ex.printStackTrace();
	    }
	    return null;
	} 
	
	//added by Ana
	private static long cpuFrequency(int cpuid) {
	    try {
	    	String pathFile = "/sys/devices/system/cpu/cpu" + cpuid + "/cpufreq/scaling_cur_freq";
	        RandomAccessFile reader = new RandomAccessFile(pathFile, "r");
	        String load = reader.readLine();

	        String[] toks = load.split("\\s+");
	        long cpuScaling = Long.parseLong(toks[0]);
	        reader.close();		
		        
		    return cpuScaling;
		    } catch (FileNotFoundException e) {
		    	return -1;
		    }
		    catch (IOException ex) {
		        ex.printStackTrace();
		    }
		    return 0;
	}

}

